package com.dt.idobox

import android.content.Context
import com.dt.idobox.AfinalHttp.AsyncTask
import com.dt.idobox.download.DownloadService
import com.dt.idobox.global.Constants
import com.dt.idobox.global.GlobalConfigMgr
import com.dt.idobox.global.IUtils
import com.dt.idobox.mgr.ChannelMgr
import com.dt.idobox.noti.INotifiMgr
import com.dt.idobox.noti.INotification
import com.dt.idobox.task.RqAppConfig
import com.dt.idobox.task.RqRateConfig
import com.dt.idobox.task.RqSwitchConfig
import com.dt.idobox.utils.TimeUtil
import com.dt.idobox.weekday.IWDNotification


/**
 * Created by wilbur on 2017/8/3.
 */
class KNotifiElf(private val mContext: Context) {

    init {
        IUtils.initBoxServerUrlVersion(mContext)
    }

    fun initPlatform() {//图表
        IUtils.initImageLoaderConfig(mContext)
        INotifiMgr.mkSurePosition(mContext)
        DownloadService.getDownloadManager(mContext)

        Constants.CACHEAPKSIZE = GlobalConfigMgr.getCacheAPKDirSize(mContext)
        Constants.CACHEAPKTIME = GlobalConfigMgr.getCacheAPKTime(mContext)
        Constants.UMENGCHANNEL = ChannelMgr.getUmengChannel(mContext)

        IUtils.initScreenSize(mContext)

        initRq()

        IWDNotification.showWeekDayNoti(mContext)
    }

    private fun initRq() {
        RqAppConfig(mContext).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR)
        RqSwitchConfig(mContext).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR)
        rqRankForMarket()
    }

    /**唤醒通知栏*/
    fun wakeNotification(){
        INotifiMgr.wakeUpNotifi(mContext)
    }

    /**
     * 请求评价接口
     */
    fun rqRankForMarket() {
        if (GlobalConfigMgr.getIsRank(mContext))
            return  // 如果评价过 返回
        if (TimeUtil.checkSameDay(GlobalConfigMgr.getLastRankAlertTime(mContext), System.currentTimeMillis() / 1000))
            return  // 如果今天提醒过 返回
        RqRateConfig(mContext).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR)
    }

    fun showINotification(){
        INotification.showINotification(mContext);
    }

    companion object {
        @Volatile var instance: KNotifiElf? = null
        val JUMP_INNER_APP = 0
        val JUMP_FROM_NOTIFCATION = 1

        fun getInstance(context: Context): KNotifiElf {
            if (instance == null) {
                synchronized(KNotifiElf::class.java) {
                    if (instance == null) {
                        instance = KNotifiElf(context)
                    }
                }
            }
            return instance!!
        }
    }
}